Index: trunk/source/processes/hadronic/cross_sections/History
===================================================================
--- trunk/source/processes/hadronic/cross_sections/History	(revision 1007)
+++ trunk/source/processes/hadronic/cross_sections/History	(revision 1055)
@@ -15,5 +15,34 @@
      ---------------------------------------------------------------
 
-01 December 2008 Vladimir Ivantchenko (hadr-cross-V09-01-07)
+21 March 2009 Vladimir Ivanchenko (hadr-cross-V09-02-04)
+------------------------------------------------------------
+- G4IonsKoxCrossSection, G4IonsShenCrossSection, G4TripathiCrossSection,
+  G4TripathiLightCrossSection - added protections against numerical 
+                                exceptions (V.Grichine)
+- G4GGNuclNuclCrossSection - Glauber-Gribov new cross section for ions 
+                             (V.Grichine)  
+
+25 February 2009 Vladimir Ivanchenko (hadr-cross-V09-02-03)
+------------------------------------------------------------
+- G4CrossSectionDataStore - added protection to the Clean method
+
+14 February 2009 Vladimir Ivanchenko (hadr-cross-V09-02-02)
+------------------------------------------------------------
+- G4CrossSectionDataStore - added Clean method
+
+06 February 2009 Vladimir Ivanchenko (hadr-cross-V09-02-01)
+------------------------------------------------------------
+
+24 January 2009 Vladimir Ivanchenko (hadr-cross-V09-02-00)
+------------------------------------------------------------
+- G4CrossSectionDataStore - moved constructor and destructor to source,
+                            added destruction of data sets, use STL
+                            vector instead of C-array
+- G4CrossSectionDataSetRegistry - new singleton to keep pointers to 
+                            cross section data sets
+- G4VCrossSectiondataSet - constructor and detructor moved to source and
+                           registration/deregistration added
+
+01 December 2008 Vladimir Ivanchenko (hadr-cross-V09-01-07)
 ------------------------------------------------------------
 G4BGGPionElasticXS, G4BGGPionInelasticXS, G4BGGNucleonInelasticXS,
Index: trunk/source/processes/hadronic/cross_sections/include/G4BGGNucleonElasticXS.hh
===================================================================
--- trunk/source/processes/hadronic/cross_sections/include/G4BGGNucleonElasticXS.hh	(revision 1007)
+++ trunk/source/processes/hadronic/cross_sections/include/G4BGGNucleonElasticXS.hh	(revision 1055)
@@ -25,5 +25,5 @@
 //
 // $Id: G4BGGNucleonElasticXS.hh,v 1.2 2008/12/01 16:50:23 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
Index: trunk/source/processes/hadronic/cross_sections/include/G4BGGNucleonInelasticXS.hh
===================================================================
--- trunk/source/processes/hadronic/cross_sections/include/G4BGGNucleonInelasticXS.hh	(revision 1007)
+++ trunk/source/processes/hadronic/cross_sections/include/G4BGGNucleonInelasticXS.hh	(revision 1055)
@@ -25,5 +25,5 @@
 //
 // $Id: G4BGGNucleonInelasticXS.hh,v 1.2 2008/12/01 16:50:23 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
Index: trunk/source/processes/hadronic/cross_sections/include/G4BGGPionElasticXS.hh
===================================================================
--- trunk/source/processes/hadronic/cross_sections/include/G4BGGPionElasticXS.hh	(revision 1007)
+++ trunk/source/processes/hadronic/cross_sections/include/G4BGGPionElasticXS.hh	(revision 1055)
@@ -25,5 +25,5 @@
 //
 // $Id: G4BGGPionElasticXS.hh,v 1.2 2008/12/01 16:50:23 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
Index: trunk/source/processes/hadronic/cross_sections/include/G4BGGPionInelasticXS.hh
===================================================================
--- trunk/source/processes/hadronic/cross_sections/include/G4BGGPionInelasticXS.hh	(revision 1007)
+++ trunk/source/processes/hadronic/cross_sections/include/G4BGGPionInelasticXS.hh	(revision 1055)
@@ -25,5 +25,5 @@
 //
 // $Id: G4BGGPionInelasticXS.hh,v 1.2 2008/12/01 16:50:23 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
Index: trunk/source/processes/hadronic/cross_sections/include/G4CrossSectionDataSetRegistry.hh
===================================================================
--- trunk/source/processes/hadronic/cross_sections/include/G4CrossSectionDataSetRegistry.hh	(revision 1007)
+++ trunk/source/processes/hadronic/cross_sections/include/G4CrossSectionDataSetRegistry.hh	(revision 1055)
@@ -25,5 +25,5 @@
 //
 // $Id: G4CrossSectionDataSetRegistry.hh,v 1.2 2009/02/14 19:22:19 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
Index: trunk/source/processes/hadronic/cross_sections/include/G4CrossSectionDataStore.hh
===================================================================
--- trunk/source/processes/hadronic/cross_sections/include/G4CrossSectionDataStore.hh	(revision 1007)
+++ trunk/source/processes/hadronic/cross_sections/include/G4CrossSectionDataStore.hh	(revision 1055)
@@ -24,4 +24,20 @@
 // ********************************************************************
 //
+// $Id: G4CrossSectionDataStore.hh,v 1.14 2009/01/24 11:54:47 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+//
+// -------------------------------------------------------------------
+//
+// GEANT4 Class header file
+//
+//
+// File name:     G4CrossSectionDataStore
+//
+//
+// Modifications:
+// 23.01.2009 V.Ivanchenko move constructor and destructor to source,
+//                         use STL vector instead of C-array
+//
+
 // Class Description
 // This is the class to which cross section data sets may be registered. 
@@ -40,4 +56,5 @@
 #include "G4Material.hh"
 #include "G4VCrossSectionDataSet.hh"
+#include <vector>
 
 class G4Nucleus;
@@ -47,55 +64,50 @@
 public:
 
-   G4CrossSectionDataStore() :
-      NDataSetList(0), verboseLevel(0)
-   {}
+  G4CrossSectionDataStore();
 
-   ~G4CrossSectionDataStore()
-   {}
+  ~G4CrossSectionDataStore();
 
-   G4double GetCrossSection(const G4DynamicParticle*, 
-                            const G4Element*, G4double aTemperature);
+  G4double GetCrossSection(const G4DynamicParticle*, 
+			   const G4Element*, G4double aTemperature);
 
-   G4double GetCrossSection(const G4DynamicParticle*, 
-                            const G4Isotope*, G4double aTemperature);
+  G4double GetCrossSection(const G4DynamicParticle*, 
+			   const G4Isotope*, G4double aTemperature);
 
-   G4double GetCrossSection(const G4DynamicParticle*, 
-                            G4double Z, G4double A, G4double aTemperature);
+  G4double GetCrossSection(const G4DynamicParticle*, 
+			   G4double Z, G4double A, G4double aTemperature);
 
-   // to replace GetMicroscopicCrossSection
-   G4double GetCrossSection(const G4DynamicParticle*, const G4Material*);
+  // to replace GetMicroscopicCrossSection
+  G4double GetCrossSection(const G4DynamicParticle*, const G4Material*);
 
-   std::pair<G4double/*Z*/, G4double/*A*/> 
-   SelectRandomIsotope(const G4DynamicParticle*, const G4Material*);
+  //std::pair<G4double/*Z*/, G4double/*A*/> 
+  // SelectRandomIsotope(const G4DynamicParticle*, const G4Material*);
 
-   G4Element* SampleZandA(const G4DynamicParticle*, const G4Material*,
-			  G4Nucleus& target);
+  G4Element* SampleZandA(const G4DynamicParticle*, const G4Material*,
+			 G4Nucleus& target);
 
-   void AddDataSet(G4VCrossSectionDataSet*);
+  void AddDataSet(G4VCrossSectionDataSet*);
 
-   void BuildPhysicsTable(const G4ParticleDefinition&);
+  void BuildPhysicsTable(const G4ParticleDefinition&);
 
-   void DumpPhysicsTable(const G4ParticleDefinition&);
+  void DumpPhysicsTable(const G4ParticleDefinition&);
 
-   void SetVerboseLevel(G4int value)
-   {
-      verboseLevel = value;
-   }
+  inline void SetVerboseLevel(G4int value)
+  {
+    verboseLevel = value;
+  }
 
-   G4int GetVerboseLevel()
-   {
-      return verboseLevel;
-   }
+  inline G4int GetVerboseLevel()
+  {
+    return verboseLevel;
+  }
 
 private:
 
+  G4VCrossSectionDataSet* whichDataSetInCharge(const G4DynamicParticle*, 
+					       const G4Element*);
 
-   G4VCrossSectionDataSet* whichDataSetInCharge(const G4DynamicParticle*, 
-                            const G4Element*);
-
-   enum { NDataSetMax = 100 };
-   G4VCrossSectionDataSet* DataSetList[NDataSetMax];
-   G4int NDataSetList;
-   G4int verboseLevel;
+  std::vector<G4VCrossSectionDataSet*> DataSetList;
+  G4int NDataSetList;
+  G4int verboseLevel;
 };
 
Index: trunk/source/processes/hadronic/cross_sections/include/G4ElectroNuclearCrossSection.hh
===================================================================
--- trunk/source/processes/hadronic/cross_sections/include/G4ElectroNuclearCrossSection.hh	(revision 1007)
+++ trunk/source/processes/hadronic/cross_sections/include/G4ElectroNuclearCrossSection.hh	(revision 1055)
@@ -25,5 +25,5 @@
 //
 //
-// GEANT4 tag $Name: geant4-09-02 $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 //
Index: trunk/source/processes/hadronic/cross_sections/include/G4GGNuclNuclCrossSection.hh
===================================================================
--- trunk/source/processes/hadronic/cross_sections/include/G4GGNuclNuclCrossSection.hh	(revision 1007)
+++ trunk/source/processes/hadronic/cross_sections/include/G4GGNuclNuclCrossSection.hh	(revision 1055)
@@ -71,4 +71,7 @@
 				G4double Z, G4double A, 
 				G4double aTemperature = 0.0);
+
+  G4double GetCoulombBarier(const G4DynamicParticle*, 
+				G4double Z, G4double A, G4double pR, G4double tR);
 
   virtual
Index: trunk/source/processes/hadronic/cross_sections/include/G4HadronCrossSections.hh
===================================================================
--- trunk/source/processes/hadronic/cross_sections/include/G4HadronCrossSections.hh	(revision 1007)
+++ trunk/source/processes/hadronic/cross_sections/include/G4HadronCrossSections.hh	(revision 1055)
@@ -25,5 +25,5 @@
 //
 //
-// GEANT4 tag $Name: geant4-09-02 $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 //
Index: trunk/source/processes/hadronic/cross_sections/include/G4PhotoNuclearCrossSection.hh
===================================================================
--- trunk/source/processes/hadronic/cross_sections/include/G4PhotoNuclearCrossSection.hh	(revision 1007)
+++ trunk/source/processes/hadronic/cross_sections/include/G4PhotoNuclearCrossSection.hh	(revision 1055)
@@ -25,5 +25,5 @@
 //
 //
-// GEANT4 tag $Name: geant4-09-02 $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 //
Index: trunk/source/processes/hadronic/cross_sections/include/G4VCrossSectionDataSet.hh
===================================================================
--- trunk/source/processes/hadronic/cross_sections/include/G4VCrossSectionDataSet.hh	(revision 1007)
+++ trunk/source/processes/hadronic/cross_sections/include/G4VCrossSectionDataSet.hh	(revision 1055)
@@ -24,7 +24,20 @@
 // ********************************************************************
 //
+// $Id: G4VCrossSectionDataSet.hh,v 1.13 2009/01/24 11:54:47 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
-// GEANT4 physics abstract class: G4VCrossSectionData -- header file
-// F.W. Jones, TRIUMF, 20-JAN-97
+// -------------------------------------------------------------------
+//
+// GEANT4 Class header file
+//
+//
+// File name:    G4VCrossSectionDataSet
+//
+// Author  F.W. Jones, TRIUMF, 20-JAN-97
+//
+// Modifications:
+// 23.01.2009 V.Ivanchenko move constructor and destructor to source
+//
+ 
 //
 // Class Description
@@ -43,56 +56,51 @@
 class G4VCrossSectionDataSet
 {
-public:
-
-   G4VCrossSectionDataSet() :
-      verboseLevel(0)
-   {}
-
-   virtual ~G4VCrossSectionDataSet()
-   {}
-
 public: //with description
 
-   // The following methods need to be implemented for each new data set.
-   virtual
-   G4bool IsApplicable(const G4DynamicParticle*, const G4Element*) = 0;
+  G4VCrossSectionDataSet();
 
-   virtual
-   G4bool IsZAApplicable(const G4DynamicParticle*, G4double /*Z*/, G4double /*A*/);
+  virtual ~G4VCrossSectionDataSet();
 
-   virtual
-   G4double GetCrossSection(const G4DynamicParticle*, 
-                            const G4Element*, 
-			    G4double aTemperature = 0.) = 0;
+  // The following methods need to be implemented for each new data set.
+  virtual
+  G4bool IsApplicable(const G4DynamicParticle*, const G4Element*) = 0;
 
-   virtual
-   G4double GetIsoCrossSection(const G4DynamicParticle*, const G4Isotope*, 
-	         	       G4double aTemperature = 0.);
+  virtual
+  G4bool IsZAApplicable(const G4DynamicParticle*, G4double /*Z*/, G4double /*A*/);
 
-   virtual
-   G4double GetIsoZACrossSection(const G4DynamicParticle*, G4double /*Z*/,
-                                 G4double /*A*/, G4double aTemperature = 0.);
+  virtual
+  G4double GetCrossSection(const G4DynamicParticle*, 
+			   const G4Element*, 
+			   G4double aTemperature = 0.) = 0;
 
-   virtual
-   void BuildPhysicsTable(const G4ParticleDefinition&) = 0;
+  virtual
+  G4double GetIsoCrossSection(const G4DynamicParticle*, const G4Isotope*, 
+			      G4double aTemperature = 0.);
 
-   virtual
-   void DumpPhysicsTable(const G4ParticleDefinition&) = 0;
+  virtual
+  G4double GetIsoZACrossSection(const G4DynamicParticle*, G4double /*Z*/,
+				G4double /*A*/, G4double aTemperature = 0.);
+
+  virtual
+  void BuildPhysicsTable(const G4ParticleDefinition&) = 0;
+
+  virtual
+  void DumpPhysicsTable(const G4ParticleDefinition&) = 0;
 
 public: // Without Description
 
-   void SetVerboseLevel(G4int value)
-   {
-      verboseLevel = value;
-   }
+  inline void SetVerboseLevel(G4int value)
+  {
+    verboseLevel = value;
+  }
 
-   G4int GetVerboseLevel()
-   {
-      return verboseLevel;
-   }
+  inline G4int GetVerboseLevel()
+  {
+    return verboseLevel;
+  }
 
 protected:
 
-   G4int verboseLevel;
+  G4int verboseLevel;
 };
 
Index: trunk/source/processes/hadronic/cross_sections/src/G4BGGNucleonElasticXS.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4BGGNucleonElasticXS.cc	(revision 1007)
+++ trunk/source/processes/hadronic/cross_sections/src/G4BGGNucleonElasticXS.cc	(revision 1055)
@@ -25,5 +25,5 @@
 //
 // $Id: G4BGGNucleonElasticXS.cc,v 1.3 2008/12/01 16:50:23 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
Index: trunk/source/processes/hadronic/cross_sections/src/G4BGGNucleonInelasticXS.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4BGGNucleonInelasticXS.cc	(revision 1007)
+++ trunk/source/processes/hadronic/cross_sections/src/G4BGGNucleonInelasticXS.cc	(revision 1055)
@@ -25,5 +25,5 @@
 //
 // $Id: G4BGGNucleonInelasticXS.cc,v 1.3 2008/12/01 16:50:23 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
Index: trunk/source/processes/hadronic/cross_sections/src/G4BGGPionElasticXS.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4BGGPionElasticXS.cc	(revision 1007)
+++ trunk/source/processes/hadronic/cross_sections/src/G4BGGPionElasticXS.cc	(revision 1055)
@@ -25,5 +25,5 @@
 //
 // $Id: G4BGGPionElasticXS.cc,v 1.3 2008/12/01 16:50:23 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
Index: trunk/source/processes/hadronic/cross_sections/src/G4BGGPionInelasticXS.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4BGGPionInelasticXS.cc	(revision 1007)
+++ trunk/source/processes/hadronic/cross_sections/src/G4BGGPionInelasticXS.cc	(revision 1055)
@@ -25,5 +25,5 @@
 //
 // $Id: G4BGGPionInelasticXS.cc,v 1.3 2008/12/01 16:50:23 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
Index: trunk/source/processes/hadronic/cross_sections/src/G4CrossSectionDataSetRegistry.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4CrossSectionDataSetRegistry.cc	(revision 1007)
+++ trunk/source/processes/hadronic/cross_sections/src/G4CrossSectionDataSetRegistry.cc	(revision 1055)
@@ -26,5 +26,5 @@
 //
 // $Id: G4CrossSectionDataSetRegistry.cc,v 1.3 2009/02/25 16:27:36 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
Index: trunk/source/processes/hadronic/cross_sections/src/G4CrossSectionDataStore.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4CrossSectionDataStore.cc	(revision 1007)
+++ trunk/source/processes/hadronic/cross_sections/src/G4CrossSectionDataStore.cc	(revision 1055)
@@ -24,4 +24,18 @@
 // ********************************************************************
 //
+// $Id: G4CrossSectionDataStore.cc,v 1.16 2009/01/24 11:54:47 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+//
+// -------------------------------------------------------------------
+//
+// GEANT4 Class file
+//
+//
+// File name:     G4CrossSectionDataStore
+//
+//
+// Modifications:
+// 23.01.2009 V.Ivanchenko add destruction of data sets
+//
 //
 
@@ -33,4 +47,10 @@
 #include "G4Nucleus.hh" 
 
+G4CrossSectionDataStore::G4CrossSectionDataStore() :
+  NDataSetList(0), verboseLevel(0)
+{}
+
+G4CrossSectionDataStore::~G4CrossSectionDataStore()
+{}
 
 G4double
@@ -392,5 +412,4 @@
   return anElement;
 }
-*/
 
 std::pair<G4double, G4double> 
@@ -513,19 +532,12 @@
   return std::pair<G4double, G4double>(ZZ, AA);
 }
-
+*/
 
 void
 G4CrossSectionDataStore::AddDataSet(G4VCrossSectionDataSet* aDataSet)
 {
-   if (NDataSetList == NDataSetMax) {
-      G4cout << "WARNING: G4CrossSectionDataStore::AddDataSet: "<<G4endl;
-      G4cout << "         reached maximum number of data sets";
-      G4cout << "         data set not added !!!!!!!!!!!!!!!!";
-      return;
-   }
-   DataSetList[NDataSetList] = aDataSet;
-   NDataSetList++;
-}
-
+  DataSetList.push_back(aDataSet);
+  NDataSetList++;
+}
 
 void
@@ -533,13 +545,9 @@
 BuildPhysicsTable(const G4ParticleDefinition& aParticleType)
 {
-   if (NDataSetList == 0) 
-   {
-     G4Exception("G4CrossSectionDataStore", "007", FatalException,
-                 "BuildPhysicsTable: no data sets registered");
-     return;
-   }
-   for (G4int i = NDataSetList-1; i >= 0; i--) {
+  if(NDataSetList > 0) {
+    for (G4int i=0; i<NDataSetList; i++) {
       DataSetList[i]->BuildPhysicsTable(aParticleType);
-   }
+    } 
+  }
 }
 
@@ -549,10 +557,11 @@
 DumpPhysicsTable(const G4ParticleDefinition& aParticleType)
 {
-   if (NDataSetList == 0) {
-      G4cout << "WARNING - G4CrossSectionDataStore::DumpPhysicsTable: no data sets registered"<<G4endl;
-      return;
-   }
-   for (G4int i = NDataSetList-1; i >= 0; i--) {
-      DataSetList[i]->DumpPhysicsTable(aParticleType);
-   }
-}
+  if (NDataSetList == 0) {
+    G4cout << "WARNING - G4CrossSectionDataStore::DumpPhysicsTable: "
+	   << " no data sets registered"<<G4endl;
+    return;
+  }
+  for (G4int i = NDataSetList-1; i >= 0; i--) {
+    DataSetList[i]->DumpPhysicsTable(aParticleType);
+  }
+}
Index: trunk/source/processes/hadronic/cross_sections/src/G4ElectroNuclearCrossSection.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4ElectroNuclearCrossSection.cc	(revision 1007)
+++ trunk/source/processes/hadronic/cross_sections/src/G4ElectroNuclearCrossSection.cc	(revision 1055)
@@ -26,5 +26,5 @@
 //
 // $Id: G4ElectroNuclearCrossSection.cc,v 1.29 2008/10/24 19:15:17 dennis Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 //
Index: trunk/source/processes/hadronic/cross_sections/src/G4GGNuclNuclCrossSection.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4GGNuclNuclCrossSection.cc	(revision 1007)
+++ trunk/source/processes/hadronic/cross_sections/src/G4GGNuclNuclCrossSection.cc	(revision 1055)
@@ -42,5 +42,5 @@
 G4GGNuclNuclCrossSection::G4GGNuclNuclCrossSection() 
 : fUpperLimit( 100000 * GeV ),
-  fLowerLimit( 0.1 * GeV ),
+  fLowerLimit( 0.1 * MeV ),
   fRadiusConst( 1.08*fermi )  // 1.1, 1.3 ?
 {
@@ -115,5 +115,5 @@
 GetIsoZACrossSection(const G4DynamicParticle* aParticle, G4double tZ, G4double tA, G4double)
 {
-  G4double xsection, sigma, cofInelastic = 2.4, cofTotal = 2.0, nucleusSquare, ratio;
+  G4double xsection, sigma, cofInelastic = 2.4, cofTotal = 2.0, nucleusSquare, cB, ratio;
 
   G4double pZ = aParticle->GetDefinition()->GetPDGCharge();
@@ -132,36 +132,94 @@
   G4double pR = GetNucleusRadius(pA); 
 
-  sigma = (pZ*tZ+pN*tN)*GetHadronNucleonXscNS(theProton, pTkin, theProton) +
+  cB = GetCoulombBarier(aParticle, tZ, tA, pR, tR);
+
+  if(cB > 0.)
+  {
+
+    sigma = (pZ*tZ+pN*tN)*GetHadronNucleonXscNS(theProton, pTkin, theProton) +
           (pZ*tN+pN*tZ)*GetHadronNucleonXscNS(theProton, pTkin, theNeutron);
 
-  nucleusSquare = cofTotal*pi*( pR*pR + tR*tR );   // basically 2piRR
-
-  ratio = sigma/nucleusSquare;
-
-  xsection =  nucleusSquare*std::log( 1. + ratio );
-
-  fTotalXsc = xsection;
-
-  fInelasticXsc = nucleusSquare*std::log( 1. + cofInelastic*ratio )/cofInelastic;
-
-  fElasticXsc   = fTotalXsc - fInelasticXsc;
-    
-  G4double difratio = ratio/(1.+ratio);
-
-  fDiffractionXsc = 0.5*nucleusSquare*( difratio - std::log( 1. + difratio ) );
-
-  // production to be checked !!! edit MK xsc
-
-  sigma = (pZ*tZ+pN*tN)*GetHadronNucleonXscMK(theProton, pTkin, theProton) +
+    nucleusSquare = cofTotal*pi*( pR*pR + tR*tR );   // basically 2piRR
+
+    ratio = sigma/nucleusSquare;
+
+    xsection =  nucleusSquare*std::log( 1. + ratio );
+
+    fTotalXsc = xsection;
+
+    fTotalXsc *= cB;
+
+    fInelasticXsc = nucleusSquare*std::log( 1. + cofInelastic*ratio )/cofInelastic;
+
+    fInelasticXsc *= cB;
+
+    fElasticXsc   = fTotalXsc - fInelasticXsc;
+
+    // if (fElasticXsc < DBL_MIN) fElasticXsc = DBL_MIN;
+    /*    
+    G4double difratio = ratio/(1.+ratio);
+
+    fDiffractionXsc = 0.5*nucleusSquare*( difratio - std::log( 1. + difratio ) );
+    */
+    // production to be checked !!! edit MK xsc
+
+    sigma = (pZ*tZ+pN*tN)*GetHadronNucleonXscMK(theProton, pTkin, theProton) +
           (pZ*tN+pN*tZ)*GetHadronNucleonXscMK(theProton, pTkin, theNeutron);
  
-  ratio = sigma/nucleusSquare;
-
-  fProductionXsc = nucleusSquare*std::log( 1. + cofInelastic*ratio )/cofInelastic;
-
-  if (fElasticXsc < 0.) fElasticXsc = 0.;
-
-  return xsection; 
-}
+    ratio = sigma/nucleusSquare;
+
+    fProductionXsc = nucleusSquare*std::log( 1. + cofInelastic*ratio )/cofInelastic;
+
+    if (fElasticXsc < 0.) fElasticXsc = 0.;
+  }
+  else
+  {
+    fInelasticXsc  = 0.;
+    fTotalXsc      = 0.;
+    fElasticXsc    = 0.;
+    fProductionXsc = 0.;
+  }
+  return fInelasticXsc;   // xsection; 
+}
+
+////////////////////////////////////////////////////////////////////////////////////////
+//
+//
+
+G4double G4GGNuclNuclCrossSection::
+GetCoulombBarier(const G4DynamicParticle* aParticle, G4double tZ, G4double tA, G4double pR, G4double tR)
+{
+  G4double ratio;
+  G4double pZ = aParticle->GetDefinition()->GetPDGCharge();
+
+
+  G4double pTkin = aParticle->GetKineticEnergy();
+  // G4double pPlab = aParticle->GetTotalMomentum();
+  G4double pM    = aParticle->GetDefinition()->GetPDGMass();
+  // G4double tM    = tZ*proton_mass_c2 + (tA-tZ)*neutron_mass_c2; // ~ 1% accuracy
+  G4double tM    = G4ParticleTable::GetParticleTable()->GetIonTable()->GetIonMass( G4int(tZ), G4int(tA) );
+  G4double pElab = pTkin + pM;
+  G4double totEcm  = std::sqrt(pM*pM + tM*tM + 2.*pElab*tM);
+  // G4double pPcm  = pPlab*tM/totEcm;
+  // G4double pTcm  = std::sqrt(pM*pM + pPcm*pPcm) - pM;
+  G4double totTcm  = totEcm - pM -tM;
+
+  G4double bC    = fine_structure_const*hbarc*pZ*tZ;
+           bC   /= pR + tR;
+           bC   /= 2.;  // 4., 2. parametrisation cof ??? vmg
+
+	   // G4cout<<"pTkin = "<<pTkin/GeV<<"; pPlab = "
+	   // <<pPlab/GeV<<"; bC = "<<bC/GeV<<"; pTcm = "<<pTcm/GeV<<G4endl;
+
+  if( totTcm <= bC ) ratio = 0.;
+  else             ratio = 1. - bC/totTcm;
+
+  // if(ratio < DBL_MIN) ratio = DBL_MIN;
+  if( ratio < 0.) ratio = 0.;
+
+  // G4cout <<"ratio = "<<ratio<<G4endl;
+  return ratio;
+}
+
 
 //////////////////////////////////////////////////////////////////////////
Index: trunk/source/processes/hadronic/cross_sections/src/G4HadronCaptureDataSet.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4HadronCaptureDataSet.cc	(revision 1007)
+++ trunk/source/processes/hadronic/cross_sections/src/G4HadronCaptureDataSet.cc	(revision 1055)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HadronCaptureDataSet.cc,v 1.8 2006/06/29 19:57:35 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 //
Index: trunk/source/processes/hadronic/cross_sections/src/G4HadronCrossSections.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4HadronCrossSections.cc	(revision 1007)
+++ trunk/source/processes/hadronic/cross_sections/src/G4HadronCrossSections.cc	(revision 1055)
@@ -25,5 +25,5 @@
 //
 //
-// GEANT4 tag $Name: geant4-09-02 $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 //
Index: trunk/source/processes/hadronic/cross_sections/src/G4HadronElasticDataSet.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4HadronElasticDataSet.cc	(revision 1007)
+++ trunk/source/processes/hadronic/cross_sections/src/G4HadronElasticDataSet.cc	(revision 1055)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HadronElasticDataSet.cc,v 1.8 2006/06/29 19:57:39 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 //
Index: trunk/source/processes/hadronic/cross_sections/src/G4HadronFissionDataSet.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4HadronFissionDataSet.cc	(revision 1007)
+++ trunk/source/processes/hadronic/cross_sections/src/G4HadronFissionDataSet.cc	(revision 1055)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HadronFissionDataSet.cc,v 1.8 2006/06/29 19:57:41 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 //
Index: trunk/source/processes/hadronic/cross_sections/src/G4HadronInelasticDataSet.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4HadronInelasticDataSet.cc	(revision 1007)
+++ trunk/source/processes/hadronic/cross_sections/src/G4HadronInelasticDataSet.cc	(revision 1055)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HadronInelasticDataSet.cc,v 1.8 2006/06/29 19:57:43 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 //
Index: trunk/source/processes/hadronic/cross_sections/src/G4IonsKoxCrossSection.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4IonsKoxCrossSection.cc	(revision 1007)
+++ trunk/source/processes/hadronic/cross_sections/src/G4IonsKoxCrossSection.cc	(revision 1055)
@@ -44,6 +44,5 @@
 
 // Apply energy check, if less than lower limit then 0 value is returned
-   if (  ke_per_N < lowerLimit )
-      return xsection;
+   // if (  ke_per_N < lowerLimit ) return xsection;
 
    G4int At = int (AA + 0.5);
@@ -57,4 +56,10 @@
 
    G4double Bc = Zt * Zp / ( ( rc / fermi ) * (  cubicrAp + cubicrAt ) );   // rc divide fermi
+   G4double targ_mass = G4ParticleTable::GetParticleTable()->GetIonTable()->GetIonMass( Zt , At ); 
+   G4double proj_mass = aParticle->GetMass(); 
+   G4double proj_momentum = aParticle->GetMomentum().mag(); 
+
+   G4double Ecm = calEcm ( proj_mass , targ_mass , proj_momentum ); 
+   if( Ecm <= Bc) return xsection;
 
    G4double Rvol = r0 * (  cubicrAp + cubicrAt );
@@ -69,10 +74,4 @@
 
    G4double Rint = Rvol + Rsurf;
-
-   G4double targ_mass = G4ParticleTable::GetParticleTable()->GetIonTable()->GetIonMass( Zt , At ); 
-   G4double proj_mass = aParticle->GetMass(); 
-   G4double proj_momentum = aParticle->GetMomentum().mag(); 
-
-   G4double Ecm = calEcm ( proj_mass , targ_mass , proj_momentum ); 
 
    xsection = pi * Rint * Rint * ( 1 - Bc / ( Ecm / MeV ) );
Index: trunk/source/processes/hadronic/cross_sections/src/G4IonsShenCrossSection.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4IonsShenCrossSection.cc	(revision 1007)
+++ trunk/source/processes/hadronic/cross_sections/src/G4IonsShenCrossSection.cc	(revision 1055)
@@ -47,6 +47,5 @@
 
 // Apply energy check, if less than lower limit then 0 value is returned
-   if (  ke_per_N < lowerLimit )
-      return xsection;
+   // if (  ke_per_N < lowerLimit ) return xsection;
 
    G4int At = G4int(AA);
@@ -63,7 +62,12 @@
    G4double r = Rt + Rp + 3.2;   // in fm
    G4double b = 1.0;   // in MeV/fm
+   G4double targ_mass = G4ParticleTable::GetParticleTable()->GetIonTable()->GetIonMass( Zt , At );
+   G4double proj_mass = aParticle->GetMass();
+   G4double proj_momentum = aParticle->GetMomentum().mag();
+
+   G4double Ecm = calEcmValue ( proj_mass , targ_mass , proj_momentum ); 
 
    G4double B = 1.44 * Zt * Zp / r - b * Rt * Rp / ( Rt + Rp ); 
-
+   if(Ecm <= B) return xsection;
    //G4double ke_per_N = aParticle->GetKineticEnergy() / Ap; 
 
@@ -74,9 +78,4 @@
    G4double R2 = 1.0 * ( At - 2 * Zt ) * Zp / ( Ap * At );
 
-   G4double targ_mass = G4ParticleTable::GetParticleTable()->GetIonTable()->GetIonMass( Zt , At );
-   G4double proj_mass = aParticle->GetMass();
-   G4double proj_momentum = aParticle->GetMomentum().mag();
-
-   G4double Ecm = calEcmValue ( proj_mass , targ_mass , proj_momentum ); 
 
    G4double R3 = 0.176 / std::pow ( G4double(Ecm) , G4double(one_third) ) * cubicrAt * cubicrAp / ( cubicrAt + cubicrAp );
Index: trunk/source/processes/hadronic/cross_sections/src/G4PhotoNuclearCrossSection.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4PhotoNuclearCrossSection.cc	(revision 1007)
+++ trunk/source/processes/hadronic/cross_sections/src/G4PhotoNuclearCrossSection.cc	(revision 1055)
@@ -26,5 +26,5 @@
 //
 // The lust update: M.V. Kossov, CERN/ITEP(Moscow) 17-June-02
-// GEANT4 tag $Name: geant4-09-02 $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 //
